package rozwiazania_zadan.r2.z1.p3_fib;

import java.util.Scanner;

public class Fibonacci1 {
	// 0 1 1 2 3 5 8 13 21 34 55
	
	// Wersja rekurencyjna, oparta bezpośrednio o definicję matematyczną.
	// Ta wersja ma złożoność wykładniczą (czyli działa w czasie proporcjonalnym do funkcji wykładniczej / w zasadzie do wartości wyliczanej liczby Fibonacciego)
	static long fib(int n) {
		if(n == 0)
			return 0;
		if(n == 1)
			return 1;
		return fib(n-1) + fib(n-2);
	}

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		
		System.out.println("Aby zakończyć, wpisz -1");
		while(true) {
			System.out.print("Podaj liczbę: ");
			int liczba = sc.nextInt();
			if(liczba < 0) break;
			
			// pomiar czasu
			long p = System.currentTimeMillis();
			var wynik = fib(liczba);
			long k = System.currentTimeMillis();
			
			System.out.println("F(" + liczba + ") = " + wynik);
			System.out.println("Obliczenie trwało " + (k-p) + " ms");
			System.out.println();
		}

	}

}
